"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _index = _interopRequireWildcard(require("../index"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

jest.mock('../util', function () {
  return _objectSpread({}, jest.requireActual('../util'), {
    generateRandomString: jest.fn().mockReturnValue('randomstring')
  });
});

var TestComponent = function TestComponent(_ref) {
  var children = _ref.children,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ["children", "className"]);

  return _react["default"].createElement("div", _extends({
    className: (0, _classnames["default"])('test-component', className)
  }, props), children);
};

TestComponent.propTypes = {
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string
};
TestComponent.defaultProps = {
  className: ''
};
describe('renders with default breakpoints', function () {
  it('with props', function () {
    var ResponsiveComponent = (0, _index["default"])(TestComponent);
    var comps = {
      'from-sm': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayFrom: "sm"
      }, "From sm")),
      'to-lg': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayTo: "lg"
      }, "To lg")),
      'from-md-to-xl': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayFrom: "md",
        displayTo: "xl"
      }, "From md - To xl"))
    };
    Object.keys(comps).forEach(function (k) {
      var firstChild = comps[k].container.firstChild;
      expect(firstChild).toMatchSnapshot("default-breakpoints:".concat(k));
    });
  });
  it('with inline props', function () {
    var FromSM = (0, _index["default"])(TestComponent, {
      displayFrom: 'sm'
    });
    var ToLG = (0, _index["default"])(TestComponent, {
      displayTo: 'lg'
    });
    var FromMDToXL = (0, _index["default"])(TestComponent, {
      displayFrom: 'md',
      displayTo: 'xl'
    });
    var comps = {
      'from-sm': (0, _react2.render)(_react["default"].createElement(FromSM, null, "From sm")),
      'to-lg': (0, _react2.render)(_react["default"].createElement(ToLG, null, "To lg")),
      'from-md-to-xl': (0, _react2.render)(_react["default"].createElement(FromMDToXL, null, "From md - To xl"))
    };
    Object.keys(comps).forEach(function (k) {
      var firstChild = comps[k].container.firstChild;
      expect(firstChild).toMatchSnapshot("default-breakpoints:".concat(k));
    });
  });
});
describe('renders with custom breakpoints', function () {
  beforeAll(function () {
    return (0, _index.setMediaQueryBreakpoints)({
      mobile: 0,
      tablet: 1024,
      desktop: 1440
    });
  });
  it('with props', function () {
    var ResponsiveComponent = (0, _index["default"])(TestComponent);
    var comps = {
      'from-mobile': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayFrom: "mobile"
      }, "From mobile")),
      'to-desktop': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayTo: "desktop"
      }, "To desktop")),
      'from-tablet-to-desktop': (0, _react2.render)(_react["default"].createElement(ResponsiveComponent, {
        displayFrom: "tablet",
        displayTo: "desktop"
      }, "From tablet - To desktop"))
    };
    Object.keys(comps).forEach(function (k) {
      var firstChild = comps[k].container.firstChild;
      expect(firstChild).toMatchSnapshot("custom-breakpoints:".concat(k));
    });
  });
  it('with inline props', function () {
    var FromMobile = (0, _index["default"])(TestComponent, {
      displayFrom: 'mobile'
    });
    var ToDesktop = (0, _index["default"])(TestComponent, {
      displayTo: 'desktop'
    });
    var FromTabletToDesktop = (0, _index["default"])(TestComponent, {
      displayFrom: 'tablet',
      displayTo: 'desktop'
    });
    var comps = {
      'from-mobile': (0, _react2.render)(_react["default"].createElement(FromMobile, null, "From mobile")),
      'to-desktop': (0, _react2.render)(_react["default"].createElement(ToDesktop, null, "To desktop")),
      'from-tablet-to-desktop': (0, _react2.render)(_react["default"].createElement(FromTabletToDesktop, null, "From tablet - To desktop"))
    };
    Object.keys(comps).forEach(function (k) {
      var firstChild = comps[k].container.firstChild;
      expect(firstChild).toMatchSnapshot("default-breakpoints:".concat(k));
    });
  });
});