"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = withResponsive;
exports.setMediaQueryBreakpoints = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = require("lodash");

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n    @media ", " {\n      display: none !important;\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT_BREAKPOINTS = {
  xs: 0,
  sm: 576,
  md: 768,
  lg: 992,
  xl: 1200,
  xxl: 1600
};

var MEDIA_QUERY_BREAKPOINTS = _objectSpread({}, DEFAULT_BREAKPOINTS); // eslint-disable-next-line no-return-assign


var setMediaQueryBreakpoints = function setMediaQueryBreakpoints(breakpoints) {
  return MEDIA_QUERY_BREAKPOINTS = _objectSpread({}, breakpoints);
};

exports.setMediaQueryBreakpoints = setMediaQueryBreakpoints;

var getDisplayWidth = function getDisplayWidth(displayFrom, displayTo) {
  return [displayFrom ? MEDIA_QUERY_BREAKPOINTS[displayFrom] : null, displayTo ? MEDIA_QUERY_BREAKPOINTS[displayTo] - 1 : null];
};

var getInverseMediaQuery = function getInverseMediaQuery(minWidth, maxWidth) {
  var queries = [];
  if (minWidth) queries.push("(max-width: ".concat(minWidth - 1, "px)"));
  if (maxWidth) queries.push("(min-width: ".concat(maxWidth + 1, "px)"));
  var mediaQuery = queries.join(' and ');
  return mediaQuery;
};

var getMediaQueryCss = function getMediaQueryCss(minWidth, maxWidth) {
  if (!minWidth && !maxWidth) return '';
  return (0, _styledComponents.css)(_templateObject(), getInverseMediaQuery(minWidth, maxWidth));
};

var matchesMediaQuery = function matchesMediaQuery(query) {
  return window.matchMedia(query).matches;
};

var MediaQuery = (0, _styledComponents["default"])(function (_ref) {
  var Component = _ref.Component,
      minWidth = _ref.minWidth,
      maxWidth = _ref.maxWidth,
      props = _objectWithoutProperties(_ref, ["Component", "minWidth", "maxWidth"]);

  return _react["default"].createElement(Component, props);
})(_templateObject2(), function (_ref2) {
  var minWidth = _ref2.minWidth,
      maxWidth = _ref2.maxWidth;
  return getMediaQueryCss(minWidth, maxWidth);
});

var mergeProps = function mergeProps(props) {
  var defaultProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return (0, _lodash.assignWith)({}, defaultProps, props, function (a, b) {
    return (0, _lodash.isUndefined)(b) ? a : b;
  });
};

function withResponsive(WrappedComponent) {
  var defaultProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  function ResponsiveWrapper(props) {
    var _mergeProps = mergeProps(props, defaultProps),
        displayFrom = _mergeProps.displayFrom,
        displayTo = _mergeProps.displayTo,
        className = _mergeProps.className,
        componentProps = _objectWithoutProperties(_mergeProps, ["displayFrom", "displayTo", "className"]); // re-render at window resize


    var _useState = (0, _react.useState)(_util.isBrowser ? [window.innerWidth, window.innerHeight] : [0, 0]),
        _useState2 = _slicedToArray(_useState, 2),
        setWindowSize = _useState2[1]; // force re-hydrate and differentiate components with a random string


    var _useState3 = (0, _react.useState)((0, _util.generateRandomString)()),
        _useState4 = _slicedToArray(_useState3, 2),
        componentIdentifier = _useState4[0],
        setComponentIdentifier = _useState4[1];

    (0, _react.useEffect)(function () {
      setComponentIdentifier((0, _util.generateRandomString)());
      if (!_util.isBrowser) return null;

      var handleResize = function handleResize() {
        return setWindowSize([window.innerWidth, window.innerHeight]);
      };

      window.addEventListener('resize', handleResize);
      return function () {
        return window.removeEventListener('resize', handleResize);
      };
    }, []);
    var componentName = (0, _react.useMemo)(function () {
      return (0, _util.getComponentName)(WrappedComponent);
    }, []);
    var classes = (0, _react.useMemo)(function () {
      return (0, _classnames["default"])(className, componentIdentifier);
    }, [className]);

    var _useMemo = (0, _react.useMemo)(function () {
      return getDisplayWidth(displayFrom, displayTo);
    }, [displayFrom, displayTo]),
        _useMemo2 = _slicedToArray(_useMemo, 2),
        minWidth = _useMemo2[0],
        maxWidth = _useMemo2[1];

    if (!minWidth && !maxWidth) {
      if (_util.isEnvDev) {
        console.warn('Warning: Not optimal to use "withResponsive" without display boundaries', componentName ? "on \"".concat(componentName, "\"") : '');
      }

      return _react["default"].createElement(WrappedComponent, _extends({}, componentProps, {
        className: classes
      }));
    }

    var WCMQ = _react["default"].createElement(MediaQuery, _extends({
      Component: WrappedComponent,
      minWidth: minWidth,
      maxWidth: maxWidth
    }, componentProps, {
      className: classes
    }));

    if (_util.isBrowser) return !matchesMediaQuery(getInverseMediaQuery(minWidth, maxWidth)) && WCMQ;
    return WCMQ; // SSR
  }

  ResponsiveWrapper.propTypes = {
    displayFrom: _propTypes["default"].oneOf(Object.keys(MEDIA_QUERY_BREAKPOINTS)),
    displayTo: _propTypes["default"].oneOf(Object.keys(MEDIA_QUERY_BREAKPOINTS))
  };
  ResponsiveWrapper.defaultProps = {
    displayFrom: undefined,
    displayTo: undefined
  };
  return ResponsiveWrapper;
}