"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateRandomString = exports.getComponentName = exports.isEnvDev = exports.isBrowser = void 0;

var _lodash = require("lodash");

var isBrowser = typeof process !== 'undefined' && (0, _lodash.get)(process, 'browser', false) || typeof window !== 'undefined';
exports.isBrowser = isBrowser;
var isEnvDev = typeof process !== 'undefined' && (0, _lodash.get)(process, 'env.NODE_ENV', 'development') === 'development';
exports.isEnvDev = isEnvDev;

var getComponentName = function getComponentName(component) {
  return (0, _lodash.get)(component, 'displayName', (0, _lodash.isFunction)(component) ? component.name : '');
};

exports.getComponentName = getComponentName;

var generateRandomString = function generateRandomString() {
  return Math.random().toString(36).substring(2, 15);
};

exports.generateRandomString = generateRandomString;